diff -rNbu binutils_060913_org/configure.in binutils_060913/configure.in
--- binutils_060913_org/configure.in	2006-08-30 15:14:18.000000000 +0200
+++ binutils_060913/configure.in	2006-09-11 11:07:02.000000000 +0200
@@ -281,6 +281,10 @@
     # noconfigdirs="tcl tk expect dejagnu make texinfo bison patch flex byacc send-pr uudecode dejagnu diff guile perl itcl gnuserv"
     noconfigdirs="$noconfigdirs expect dejagnu autoconf automake send-pr rcs guile perl texinfo libtool newlib"
     ;;
+  x86_64-*-mingw64*)
+    # noconfigdirs="tcl tk expect dejagnu make texinfo bison patch flex byacc send-pr uudecode dejagnu diff guile perl itcl gnuserv"
+    noconfigdirs="$noconfigdirs expect dejagnu autoconf automake send-pr rcs guile perl texinfo libtool newlib"
+    ;;
   i[[3456789]]86-*-beos*)
     noconfigdirs="$noconfigdirs tk itcl libgui gdb"
     ;;
@@ -618,6 +622,10 @@
     target_configdirs="$target_configdirs target-winsup"
     noconfigdirs="$noconfigdirs expect target-libgloss target-newlib ${libgcj}"
     ;;    
+  x86_64-*-mingw64*)
+    target_configdirs="$target_configdirs target-winsup"
+    noconfigdirs="$noconfigdirs expect target-libgloss target-newlib ${libgcj}"
+    ;;    
   *-*-cygwin*)
     target_configdirs="$target_configdirs target-libtermcap target-winsup"
     noconfigdirs="$noconfigdirs target-gperf target-libgloss ${libgcj}"
@@ -936,6 +944,8 @@
     ;;
   *-mingw32*)
     ;;
+  *-mingw64*)
+    ;;
   *-interix*)
     host_makefile_frag="config/mh-interix"
     ;;
diff -rNbu binutils_060913_org/gas/ChangeLog binutils_060913/gas/ChangeLog
--- binutils_060913_org/gas/ChangeLog	2006-09-13 02:46:08.000000000 +0200
+++ binutils_060913/gas/ChangeLog	2006-09-13 11:08:34.000000000 +0200
@@ -1,3 +1,15 @@
+2006-09-13	Kai Tietz	<Kai.Tietz@onevision.com>
+
+	* configure.in:	Add new target x86_64-pc-mingw64
+	* configure.tgt:	Add new target x86_64-pc-mingw64
+	* config/obj-coff.h:	Add handling for TE_PEP target specific code and definitions
+	* config/tc-i386.c:		Add new targets
+		md_parse_option:			Add targets to OPTION_64
+		x86_64_target_format:	Add new method for setup proper default target cpu mode
+	* config/te-pep.h:		Add new target definition header
+		TE_PEP:				Identifies new target architecture
+		COFF_WITH_pex64:	Set proper includes in bfd
+
 2006-09-13  Alan Modra  <amodra@bigpond.net.au>
 
 	PR gas/3165
diff -rNbu binutils_060913_org/gas/config/obj-coff.h binutils_060913/gas/config/obj-coff.h
--- binutils_060913_org/gas/config/obj-coff.h	2006-06-07 13:27:57.000000000 +0200
+++ binutils_060913/gas/config/obj-coff.h	2006-09-11 14:17:40.000000000 +0200
@@ -55,16 +55,30 @@
 #endif
 
 #ifdef TC_I386
+#ifndef TE_PEP
 #include "coff/i386.h"
+#else
+#include "coff/x86_64.h"
+#endif
 
 #ifdef TE_PE
+#ifdef TE_PEP
+extern const char *x86_64_target_format PARAMS ((void));
+#define TARGET_FORMAT x86_64_target_format ()
+#define COFF_TARGET_FORMAT "pe-x86-64"
+#else
 #define TARGET_FORMAT "pe-i386"
 #endif
+#endif
 
 #ifndef TARGET_FORMAT
+#ifdef TE_PEP
+#define TARGET_FORMAT "coff-x86-64"
+#else
 #define TARGET_FORMAT "coff-i386"
 #endif
 #endif
+#endif
 
 #ifdef TC_M68K
 #include "coff/m68k.h"
diff -rNbu binutils_060913_org/gas/config/tc-i386.c binutils_060913/gas/config/tc-i386.c
--- binutils_060913_org/gas/config/tc-i386.c	2006-08-02 18:25:14.000000000 +0200
+++ binutils_060913/gas/config/tc-i386.c	2006-09-11 14:26:14.000000000 +0200
@@ -5768,7 +5768,7 @@
 
 struct option md_longopts[] = {
   {"32", no_argument, NULL, OPTION_32},
-#if defined (OBJ_ELF) || defined (OBJ_MAYBE_ELF)
+#if defined (OBJ_ELF) || defined (OBJ_MAYBE_ELF) || defined(TE_PEP)
   {"64", no_argument, NULL, OPTION_64},
 #endif
   {"divide", no_argument, NULL, OPTION_DIVIDE},
@@ -5793,7 +5793,8 @@
       quiet_warnings = 1;
       break;
 
-#if defined (OBJ_ELF) || defined (OBJ_MAYBE_ELF)
+#if defined (OBJ_ELF) || defined (OBJ_MAYBE_ELF) || defined(TE_PEP)
+#ifndef TE_PEP
       /* -Qy, -Qn: SVR4 arguments controlling whether a .comment section
 	 should be emitted or not.  FIXME: Not implemented.  */
     case 'Q':
@@ -5812,14 +5813,15 @@
       /* -s: On i386 Solaris, this tells the native assembler to use
 	 .stab instead of .stab.excl.  We always use .stab anyhow.  */
       break;
-
+#endif
     case OPTION_64:
       {
 	const char **list, **l;
 
 	list = bfd_target_list ();
 	for (l = list; *l != NULL; l++)
-	  if (strncmp (*l, "elf64-x86-64", 12) == 0)
+	  if (strcmp (*l, "elf64-x86-64") == 0 || strcmp(*l,"coff-x86-64")==0 || strcmp(*l,"pe-x86-64")==0 ||
+		  strcmp(*l,"pei-x86-64")==0)
 	    {
 	      default_arch = "x86_64";
 	      break;
@@ -5927,6 +5929,22 @@
 
 }
 
+#if defined(TE_PEP)
+const char *x86_64_target_format(void)
+{
+	if (!strcmp (default_arch, "x86_64")) {
+		set_code_flag (CODE_64BIT);
+		return COFF_TARGET_FORMAT;
+	} else if (!strcmp (default_arch, "i386")) {
+		set_code_flag (CODE_32BIT);
+		return "coff-i386";
+	} else
+		as_fatal (_("Unknown architecture"));
+	abort ();
+	return NULL;
+}
+#endif
+
 #if ((defined (OBJ_MAYBE_COFF) && defined (OBJ_MAYBE_AOUT)) \
      || defined (OBJ_ELF) || defined (OBJ_MAYBE_ELF))
 
diff -rNbu binutils_060913_org/gas/config/te-pep.h binutils_060913/gas/config/te-pep.h
--- binutils_060913_org/gas/config/te-pep.h	1970-01-01 01:00:00.000000000 +0100
+++ binutils_060913/gas/config/te-pep.h	2006-09-11 14:26:46.000000000 +0200
@@ -0,0 +1,10 @@
+#define TE_PEP
+#define COFF_WITH_pex64
+
+#define TE_PE
+#define LEX_AT (LEX_BEGIN_NAME | LEX_NAME) /* Can have @'s inside labels.  */
+
+/* The PE format supports long section names.  */
+#define COFF_LONG_SECTION_NAMES
+
+#include "obj-format.h"
diff -rNbu binutils_060913_org/gas/configure.in binutils_060913/gas/configure.in
--- binutils_060913_org/gas/configure.in	2006-08-02 16:26:07.000000000 +0200
+++ binutils_060913/gas/configure.in	2006-09-11 14:11:30.000000000 +0200
@@ -417,6 +417,19 @@
       ;;
     esac
   ;;
+  x86_64)
+    case ${obj_format} in
+    aout)
+      emulations="$emulations i386coff i386elf"
+      ;;
+    coff)
+      emulations="$emulations i386aout i386elf"
+    ;;
+    elf)
+      emulations="$emulations i386aout i386coff"
+      ;;
+    esac
+  ;;
   esac
 fi
 
@@ -459,6 +472,7 @@
   coff)
     case ${target_cpu_type} in
       i386) AC_DEFINE(I386COFF, 1, [Using i386 COFF?]) ;;
+      x86_64) AC_DEFINE(I386COFF, 1, [Using i386 COFF?]) ;;
       m68k) AC_DEFINE(M68KCOFF, 1, [Using m68k COFF?]) ;;
       m88k) AC_DEFINE(M88KCOFF, 1, [Using m88k COFF?]) ;;
     esac
diff -rNbu binutils_060913_org/gas/configure.tgt binutils_060913/gas/configure.tgt
--- binutils_060913_org/gas/configure.tgt	2006-08-15 20:23:11.000000000 +0200
+++ binutils_060913/gas/configure.tgt	2006-09-11 14:13:06.000000000 +0200
@@ -77,7 +77,7 @@
   strongarm*b)		cpu_type=arm endian=big ;;
   strongarm*)		cpu_type=arm endian=little ;;
   v850*)		cpu_type=v850 ;;
-  x86_64)		cpu_type=i386 arch=x86_64;;
+  x86_64*)		cpu_type=i386 arch=x86_64;;
   xscale*be|xscale*b)	cpu_type=arm endian=big ;;
   xscale*)		cpu_type=arm endian=little ;;
   xtensa*)		cpu_type=xtensa arch=xtensa ;;
@@ -210,6 +210,7 @@
   i386-*-cygwin*)			fmt=coff em=pe ;;
   i386-*-interix*)			fmt=coff em=interix ;;
   i386-*-mingw32*)			fmt=coff em=pe ;;
+  i386-*-mingw64*)			fmt=coff em=pep ;;
   i386-*-nto-qnx*)			fmt=elf ;;
   i386-*-*nt*)				fmt=coff em=pe ;;
   i386-*-chaos)				fmt=elf ;;
diff -rNbu binutils_060913_org/gas/testsuite/ChangeLog binutils_060913/gas/testsuite/ChangeLog
--- binutils_060913_org/gas/testsuite/ChangeLog	2006-09-08 19:08:05.000000000 +0200
+++ binutils_060913/gas/testsuite/ChangeLog	2006-09-13 11:09:11.000000000 +0200
@@ -1,3 +1,21 @@
+2006-09-13	Kai Tietz	<Kai.Tietz@onevision.com>
+
+	* i386/immed64.d:	Add #pass for avoid proplems with alignment paddings
+	* i386/rex.d:		Changed for target matching
+	* i386/x86-64-addr32.d:	Changed for target matching and padding
+	* i386/x86-64-branch.d:	Changed for target matching and padding
+	* i386/x86-64-crx-suffix.d:	Changed for target matching and padding
+	* i386/x86-64-crx.d:	Changed for target matching
+	* i386/x86-64-drx-suffix.d:	Changed for target matching and padding
+	* i386/x86-64-crx-suffix.d:	Changed for target matching and padding
+	* i386/x86-64-opcode.d:	Changed for target matching
+	* i386/x86-64-pcrel.d:	Changed for target matching and relocation fixing
+	* i386/x86-64-rip.d:	Changed for target matching and padding
+	* i386/x86-64-stack-intel.d:	Changed for target matching and padding
+	* i386/x86-64-stack-suffix.d:	Changed for target matching and padding
+	* i386/x86-64-stack.d:	Changed for target matching and padding
+	* i386/x86_64.d:	Changed section specifier to .text
+
 2006-09-08  Kazu Hirata  <kazu@codesourcery.com>
 
 	* lib/gas-dg.exp (gas-dg-test): Treat $dir as a literal.
diff -rNbu binutils_060913_org/gas/testsuite/gas/all/gas.exp binutils_060913/gas/testsuite/gas/all/gas.exp
--- binutils_060913_org/gas/testsuite/gas/all/gas.exp	2005-11-21 05:30:32.000000000 +0100
+++ binutils_060913/gas/testsuite/gas/all/gas.exp	2006-09-11 14:28:34.000000000 +0200
@@ -207,6 +207,7 @@
      || [istarget i*86-*-isc*] \
      || [istarget i*86-*-go32*] \
      || [istarget i*86-*-cygwin*] \
+     || [istarget x86_64-*-mingw64*] \
      || [istarget i*86-*-*nt] \
      || [istarget i*86-*-interix*] \
      || ([istarget i960-*-vxworks5.*] && ![istarget i960-*-vxworks5.0*]) } {
diff -rNbu binutils_060913_org/gas/testsuite/gas/i386/i386.exp binutils_060913/gas/testsuite/gas/i386/i386.exp
--- binutils_060913_org/gas/testsuite/gas/i386/i386.exp	2006-07-14 00:25:46.000000000 +0200
+++ binutils_060913/gas/testsuite/gas/i386/i386.exp	2006-09-11 16:09:42.000000000 +0200
@@ -155,7 +155,9 @@
     run_dump_test "x86-64-rep-suffix"
     run_dump_test "x86-64-gidt"
     run_dump_test "x86-64-nops"
+    if ![istarget "*-*-mingw64*"] then {
     run_dump_test "x86-64-nops-1"
+    }
     run_dump_test "x86-64-nops-1-k8"
     run_dump_test "x86-64-nops-1-nocona"
     run_dump_test "x86-64-nops-1-merom"
diff -rNbu binutils_060913_org/gas/testsuite/gas/i386/immed64.d binutils_060913/gas/testsuite/gas/i386/immed64.d
--- binutils_060913_org/gas/testsuite/gas/i386/immed64.d	2005-07-26 17:34:11.000000000 +0200
+++ binutils_060913/gas/testsuite/gas/i386/immed64.d	2006-09-11 14:29:36.000000000 +0200
@@ -57,3 +57,4 @@
 [ 	]*[0-9a-fA-F]+:[ 	]+e5 04[ 	]+inl? +\$0x4,%eax
 [ 	]*[0-9a-fA-F]+:[ 	]+e5 08[ 	]+inl? +\$0x8,%eax
 [ 	]*[0-9a-fA-F]+:[ 	]+e5 00[ 	]+inl? +\$0x0,%eax
+#pass
diff -rNbu binutils_060913_org/gas/testsuite/gas/i386/rex.d binutils_060913/gas/testsuite/gas/i386/rex.d
--- binutils_060913_org/gas/testsuite/gas/i386/rex.d	2005-12-14 09:57:06.000000000 +0100
+++ binutils_060913/gas/testsuite/gas/i386/rex.d	2006-09-11 14:30:06.000000000 +0200
@@ -1,7 +1,7 @@
 #objdump: -dw
 #name: x86-64 manual rex prefix use
 
-.*: +file format elf64-x86-64
+.*: +file format .*
 
 Disassembly of section .text:
 
diff -rNbu binutils_060913_org/gas/testsuite/gas/i386/x86-64-addr32.d binutils_060913/gas/testsuite/gas/i386/x86-64-addr32.d
--- binutils_060913_org/gas/testsuite/gas/i386/x86-64-addr32.d	2004-07-21 18:09:43.000000000 +0200
+++ binutils_060913/gas/testsuite/gas/i386/x86-64-addr32.d	2006-09-11 14:31:36.000000000 +0200
@@ -2,7 +2,7 @@
 #objdump: -drw
 #name: x86-64 32-bit addressing
 
-.*: +file format elf64-x86-64
+.*: +file format .*
 
 Disassembly of section .text:
 
@@ -11,3 +11,4 @@
 [	 ]*8:[	 ]+67 49 8d 80 00 00 00 00[	 ]+addr32[	 ]+lea[ 	]+0x0\(%r8d?\),%rax.*
 [	 ]*10:[	 ]+67 48 8d 05 00 00 00 00[	 ]+addr32[	 ]+lea[ 	]+0\(%[re]ip\),%rax.*
 [	 ]*18:[	 ]+67 48 8d 04 25 00 00 00 00[	 ]+addr32[	 ]+lea[ 	]+0x0,%rax.*
+#pass
diff -rNbu binutils_060913_org/gas/testsuite/gas/i386/x86-64-branch.d binutils_060913/gas/testsuite/gas/i386/x86-64-branch.d
--- binutils_060913_org/gas/testsuite/gas/i386/x86-64-branch.d	2005-05-07 15:30:02.000000000 +0200
+++ binutils_060913/gas/testsuite/gas/i386/x86-64-branch.d	2006-09-11 14:32:00.000000000 +0200
@@ -2,7 +2,7 @@
 #objdump: -drw
 #name: x86-64 indirect branch
 
-.*: +file format elf64-x86-64
+.*: +file format .*
 
 Disassembly of section .text:
 
@@ -11,3 +11,4 @@
 [	 ]*2:[	 ]+ff d0[	 ]+callq[	 ]+\*%rax
 [	 ]*4:[	 ]+ff e0[	 ]+jmpq[	 ]+\*%rax
 [	 ]*6:[	 ]+ff e0[	 ]+jmpq[	 ]+\*%rax
+#pass
diff -rNbu binutils_060913_org/gas/testsuite/gas/i386/x86-64-crx-suffix.d binutils_060913/gas/testsuite/gas/i386/x86-64-crx-suffix.d
--- binutils_060913_org/gas/testsuite/gas/i386/x86-64-crx-suffix.d	2006-02-12 18:26:21.000000000 +0100
+++ binutils_060913/gas/testsuite/gas/i386/x86-64-crx-suffix.d	2006-09-11 14:33:10.000000000 +0200
@@ -2,7 +2,7 @@
 #name: x86-64 control register related opcodes (with suffixes)
 #source: x86-64-crx.s
 
-.*: +file format elf64-x86-64
+.*: +file format .*
 
 Disassembly of section .text:
 
@@ -19,3 +19,4 @@
 [ 	]*[0-9a-f]+:	44 0f 20 c7[ 	]+movq[ 	]+?%cr8,%rdi
 [ 	]*[0-9a-f]+:	44 0f 22 c0[ 	]+movq[ 	]+?%rax,%cr8
 [ 	]*[0-9a-f]+:	44 0f 22 c7[ 	]+movq[ 	]+?%rdi,%cr8
+#pass
diff -rNbu binutils_060913_org/gas/testsuite/gas/i386/x86-64-crx.d binutils_060913/gas/testsuite/gas/i386/x86-64-crx.d
--- binutils_060913_org/gas/testsuite/gas/i386/x86-64-crx.d	2006-02-11 18:00:58.000000000 +0100
+++ binutils_060913/gas/testsuite/gas/i386/x86-64-crx.d	2006-09-11 14:32:40.000000000 +0200
@@ -2,7 +2,7 @@
 #name: x86-64 control register related opcodes
 #source: x86-64-crx.s
 
-.*: +file format elf64-x86-64
+.*: +file format .*
 
 Disassembly of section .text:
 
@@ -19,3 +19,4 @@
 [ 	]*[0-9a-f]+:	44 0f 20 c7[ 	]+movq?[ 	]+?%cr8,%rdi
 [ 	]*[0-9a-f]+:	44 0f 22 c0[ 	]+movq?[ 	]+?%rax,%cr8
 [ 	]*[0-9a-f]+:	44 0f 22 c7[ 	]+movq?[ 	]+?%rdi,%cr8
+#pass
diff -rNbu binutils_060913_org/gas/testsuite/gas/i386/x86-64-drx-suffix.d binutils_060913/gas/testsuite/gas/i386/x86-64-drx-suffix.d
--- binutils_060913_org/gas/testsuite/gas/i386/x86-64-drx-suffix.d	2006-02-11 19:08:35.000000000 +0100
+++ binutils_060913/gas/testsuite/gas/i386/x86-64-drx-suffix.d	2006-09-11 14:33:44.000000000 +0200
@@ -2,7 +2,7 @@
 #name: x86-64 debug register related opcodes (with suffixes)
 #source: x86-64-drx.s
 
-.*: +file format elf64-x86-64
+.*: +file format .*
 
 Disassembly of section .text:
 
@@ -19,3 +19,4 @@
 [ 	]*[0-9a-f]+:	44 0f 21 c7[ 	]+movq[ 	]+?%db8,%rdi
 [ 	]*[0-9a-f]+:	44 0f 23 c0[ 	]+movq[ 	]+?%rax,%db8
 [ 	]*[0-9a-f]+:	44 0f 23 c7[ 	]+movq[ 	]+?%rdi,%db8
+#pass
diff -rNbu binutils_060913_org/gas/testsuite/gas/i386/x86-64-drx.d binutils_060913/gas/testsuite/gas/i386/x86-64-drx.d
--- binutils_060913_org/gas/testsuite/gas/i386/x86-64-drx.d	2006-02-11 19:08:35.000000000 +0100
+++ binutils_060913/gas/testsuite/gas/i386/x86-64-drx.d	2006-09-11 14:33:30.000000000 +0200
@@ -1,7 +1,7 @@
 #objdump: -dw
 #name: x86-64 debug register related opcodes
 
-.*: +file format elf64-x86-64
+.*: +file format .*
 
 Disassembly of section .text:
 
@@ -18,3 +18,4 @@
 [ 	]*[0-9a-f]+:	44 0f 21 c7[ 	]+movq?[ 	]+?%db8,%rdi
 [ 	]*[0-9a-f]+:	44 0f 23 c0[ 	]+movq?[ 	]+?%rax,%db8
 [ 	]*[0-9a-f]+:	44 0f 23 c7[ 	]+movq?[ 	]+?%rdi,%db8
+#pass
diff -rNbu binutils_060913_org/gas/testsuite/gas/i386/x86-64-opcode.d binutils_060913/gas/testsuite/gas/i386/x86-64-opcode.d
--- binutils_060913_org/gas/testsuite/gas/i386/x86-64-opcode.d	2006-07-18 22:25:40.000000000 +0200
+++ binutils_060913/gas/testsuite/gas/i386/x86-64-opcode.d	2006-09-11 14:34:30.000000000 +0200
@@ -2,7 +2,7 @@
 #objdump: -drw
 #name: x86-64 opcode
 
-.*: +file format elf64-x86-64
+.*: +file format .*
 
 Disassembly of section .text:
 
diff -rNbu binutils_060913_org/gas/testsuite/gas/i386/x86-64-pcrel.d binutils_060913/gas/testsuite/gas/i386/x86-64-pcrel.d
--- binutils_060913_org/gas/testsuite/gas/i386/x86-64-pcrel.d	2005-06-17 10:03:58.000000000 +0200
+++ binutils_060913/gas/testsuite/gas/i386/x86-64-pcrel.d	2006-09-06 12:56:52.000000000 +0200
@@ -1,16 +1,16 @@
 #objdump: -drw
 #name: x86-64 pcrel
 
-.*: +file format elf64-x86-64
+.*: +file format .*
 
 Disassembly of section .text:
 
 0+000 <_start>:
-[	 ]*[0-9a-f]+:[	 ]+b0 00[	 ]+movb?[	 ]+\$(0x)?0,%al[	 ]*[0-9a-f]+:[	 ]+R_X86_64_PC8[	 ]+xtrn\+(0x)?1
-[	 ]*[0-9a-f]+:[	 ]+66 b8 00 00[	 ]+movw?[	 ]+\$(0x)?0,%ax[	 ]*[0-9a-f]+:[	 ]+R_X86_64_PC16[	 ]+xtrn\+(0x)?2
-[	 ]*[0-9a-f]+:[	 ]+b8( 00){4}[	 ]+movl?[	 ]+\$(0x)?0,%eax[	 ]*[0-9a-f]+:[	 ]+R_X86_64_PC32[	 ]+xtrn\+(0x)?1
-[	 ]*[0-9a-f]+:[	 ]+48 c7 c0( 00){4}[	 ]+movq?[	 ]+\$(0x)?0,%rax[	 ]*[0-9a-f]+:[	 ]+R_X86_64_PC32[	 ]+xtrn\+(0x)?3
-[	 ]*[0-9a-f]+:[	 ]+48 b8( 00){8}[	 ]+mov(abs)?q?[	 ]+\$(0x)?0,%rax[	 ]*[0-9a-f]+:[	 ]+R_X86_64_PC64[	 ]+xtrn\+(0x)?2
+[	 ]*[0-9a-f]+:[	 ]+b0 0[02]+[	 ]+movb?[	 ]+\$(0x)?[02]+,%al[	 ]*[0-9a-f]+:[	 ]+R_X86_64_PC8[	 ]+xtrn(\+(0x)?1)?
+[	 ]*[0-9a-f]+:[	 ]+66 b8 0[04]+ 00[	 ]+movw?[	 ]+\$(0x)?[04]+,%ax[	 ]*[0-9a-f]+:[	 ]+R_X86_64_PC16[	 ]+xtrn(\+(0x)?2)?
+[	 ]*[0-9a-f]+:[	 ]+b8 0[05]+( 00){3}[	 ]+movl?[	 ]+\$(0x)?[05]+,%eax[	 ]*[0-9a-f]+:[	 ]+R_X86_64_PC32[	 ]+xtrn(\+(0x)?1)?
+[	 ]*[0-9a-f]+:[	 ]+48 c7 c0 0[07]+( 00){3}[	 ]+movq?[	 ]+\$(0x)?[07]+,%rax[	 ]*[0-9a-f]+:[	 ]+R_X86_64_PC32[	 ]+xtrn(\+(0x)?3)?
+[	 ]*[0-9a-f]+:[	 ]+48 b8 0[0a]+( 00){7}[	 ]+mov(abs)?q?[	 ]+\$(0x)?[0a]+,%rax[	 ]*[0-9a-f]+:[	 ]+R_X86_64_PC64[	 ]+xtrn(\+(0x)?2)?
 [	 ]*[0-9a-f]+:[	 ]+b0 00[	 ]+movb?[	 ]+\$(0x)?0,%al[	 ]*[0-9a-f]+:[	 ]+R_X86_64_8[	 ]+xtrn
 [	 ]*[0-9a-f]+:[	 ]+66 b8 00 00[	 ]+movw?[	 ]+\$(0x)?0,%ax[	 ]*[0-9a-f]+:[	 ]+R_X86_64_16[	 ]+xtrn
 [	 ]*[0-9a-f]+:[	 ]+b8( 00){4}[	 ]+movl?[	 ]+\$(0x)?0,%eax[	 ]*[0-9a-f]+:[	 ]+R_X86_64_32[	 ]+xtrn
diff -rNbu binutils_060913_org/gas/testsuite/gas/i386/x86-64-rip.d binutils_060913/gas/testsuite/gas/i386/x86-64-rip.d
--- binutils_060913_org/gas/testsuite/gas/i386/x86-64-rip.d	2004-07-21 18:09:43.000000000 +0200
+++ binutils_060913/gas/testsuite/gas/i386/x86-64-rip.d	2006-09-11 14:35:50.000000000 +0200
@@ -2,7 +2,7 @@
 #objdump: -drw
 #name: x86-64 rip addressing
 
-.*: +file format elf64-x86-64
+.*: +file format .*
 
 Disassembly of section .text:
 
@@ -11,3 +11,4 @@
 [	 ]*6:[	 ]+8d 05 11 11 11 11[	 ]+lea[	 ]+286331153\(%rip\),%eax[ 	]*(#.*)?
 [	 ]*c:[	 ]+8d 05 01 00 00 00[	 ]+lea[	 ]+1\(%rip\),%eax[ 	]*(#.*)?
 [	 ]*12:[	 ]+8d 05 00 00 00 00[	 ]+lea[	 ]+0\(%rip\),%eax[ 	]*(#.*)?
+#pass
diff -rNbu binutils_060913_org/gas/testsuite/gas/i386/x86-64-stack-intel.d binutils_060913/gas/testsuite/gas/i386/x86-64-stack-intel.d
--- binutils_060913_org/gas/testsuite/gas/i386/x86-64-stack-intel.d	2005-09-28 17:34:51.000000000 +0200
+++ binutils_060913/gas/testsuite/gas/i386/x86-64-stack-intel.d	2006-09-11 14:36:18.000000000 +0200
@@ -2,7 +2,7 @@
 #name: x86-64 stack-related opcodes (Intel mode)
 #source: x86-64-stack.s
 
-.*: +file format elf64-x86-64
+.*: +file format .*
 
 Disassembly of section .text:
 
diff -rNbu binutils_060913_org/gas/testsuite/gas/i386/x86-64-stack-suffix.d binutils_060913/gas/testsuite/gas/i386/x86-64-stack-suffix.d
--- binutils_060913_org/gas/testsuite/gas/i386/x86-64-stack-suffix.d	2005-09-28 17:34:51.000000000 +0200
+++ binutils_060913/gas/testsuite/gas/i386/x86-64-stack-suffix.d	2006-09-11 14:36:46.000000000 +0200
@@ -2,7 +2,7 @@
 #name: x86-64 stack-related opcodes (with suffixes)
 #source: x86-64-stack.s
 
-.*: +file format elf64-x86-64
+.*: +file format .*
 
 Disassembly of section .text:
 
diff -rNbu binutils_060913_org/gas/testsuite/gas/i386/x86-64-stack.d binutils_060913/gas/testsuite/gas/i386/x86-64-stack.d
--- binutils_060913_org/gas/testsuite/gas/i386/x86-64-stack.d	2005-09-28 17:34:51.000000000 +0200
+++ binutils_060913/gas/testsuite/gas/i386/x86-64-stack.d	2006-09-11 14:37:04.000000000 +0200
@@ -1,7 +1,7 @@
 #objdump: -dw
 #name: x86-64 stack-related opcodes
 
-.*: +file format elf64-x86-64
+.*: +file format .*
 
 Disassembly of section .text:
 
diff -rNbu binutils_060913_org/gas/testsuite/gas/i386/x86_64.d binutils_060913/gas/testsuite/gas/i386/x86_64.d
--- binutils_060913_org/gas/testsuite/gas/i386/x86_64.d	2006-03-07 21:18:05.000000000 +0100
+++ binutils_060913/gas/testsuite/gas/i386/x86_64.d	2006-09-11 15:55:16.000000000 +0200
@@ -6,7 +6,7 @@
 
 Disassembly of section .text:
 
-0+ <bar-0x1a7>:
+0+ <.*>:
 [ 	]+0:	01 ca[ 	]+add[ 	]+%ecx,%edx
 [ 	]+2:	44 01 ca[ 	]+add[ 	]+%r9d,%edx
 [ 	]+5:	41 01 ca[ 	]+add[ 	]+%ecx,%r10d
diff -rNbu binutils_060913_org/include/coff/ChangeLog binutils_060913/include/coff/ChangeLog
--- binutils_060913_org/include/coff/ChangeLog	2006-02-05 12:57:34.000000000 +0100
+++ binutils_060913/include/coff/ChangeLog	2006-09-11 18:52:20.000000000 +0200
@@ -1,3 +1,14 @@
+2006-09-11	Kai Tietz	<Kai.Tietz@onevision.com>
+
+	* external.h:	Add proper external_aouthdr64 structure (without data_start member)
+		AOUTHDRSZ64:	Set according structure size
+		AOUTHDR64:		As typedef of external_aouthdr64 structure
+	* internal.h:	Add relocation identifiers for coff
+	* pe.h:	Add define IMAGE_FILE_MACHINE_AMD64 the coff signature
+		PEPAOUTHDR:		Adjust structure to have proper size (using AOUTHDR64)
+		PEPAOUTSZ:		Calculated size of 240
+	* x86_64.h:	Coff information for x86_64 (AMD64)
+
 2006-02-05  Arnold Metselaar  <arnold.metselaar@planet.nl>
 
 	* internal.h: Add relocation number R_IMM24 for Z80.
diff -rNbu binutils_060913_org/include/coff/external.h binutils_060913/include/coff/external.h
--- binutils_060913_org/include/coff/external.h	2005-05-10 12:21:09.000000000 +0200
+++ binutils_060913/include/coff/external.h	2006-09-11 12:30:40.000000000 +0200
@@ -55,6 +55,20 @@
 
 #define AOUTHDRSZ 28
 #define AOUTSZ 28
+
+typedef struct external_aouthdr64
+  {
+    char magic[2];	/* type of file				*/
+    char vstamp[2];	/* version stamp			*/
+    char tsize[4];	/* text size in bytes, padded to FW bdry*/
+    char dsize[4];	/* initialized data "  "		*/
+    char bsize[4];	/* uninitialized data "   "		*/
+    char entry[4];	/* entry pt.				*/
+    char text_start[4];	/* base of text used for this file 	*/
+  }
+AOUTHDR64;
+#define AOUTHDRSZ64	24
+
 #endif
 
 #ifndef DO_NOT_DEFINE_SCNHDR
diff -rNbu binutils_060913_org/include/coff/pe.h binutils_060913/include/coff/pe.h
--- binutils_060913_org/include/coff/pe.h	2005-05-10 12:21:09.000000000 +0200
+++ binutils_060913/include/coff/pe.h	2006-09-11 12:33:56.000000000 +0200
@@ -119,6 +119,7 @@
 #define IMAGE_FILE_MACHINE_THUMB             0x01c2
 #define IMAGE_FILE_MACHINE_TRICORE           0x0520
 #define IMAGE_FILE_MACHINE_WCEMIPSV2         0x0169
+#define IMAGE_FILE_MACHINE_AMD64             0x8664  // AMD64 (K8)
 
 #define IMAGE_SUBSYSTEM_UNKNOWN			 0
 #define IMAGE_SUBSYSTEM_NATIVE			 1
@@ -267,7 +268,7 @@
    of just 4 bytes long.  */
 typedef struct 
 {
-  AOUTHDR standard;
+  AOUTHDR64 standard;
 
   /* NT extra fields; see internal.h for descriptions.  */
   char  ImageBase[8];
@@ -294,7 +295,7 @@
   /* IMAGE_DATA_DIRECTORY DataDirectory[IMAGE_NUMBEROF_DIRECTORY_ENTRIES];  */
   char  DataDirectory[16][2][4]; /* 16 entries, 2 elements/entry, 4 chars.  */
 } PEPAOUTHDR;
-#define PEPAOUTSZ	240
+#define PEPAOUTSZ	(AOUTHDRSZ64+196+5*4) /* 240 */
   
 #undef  E_FILNMLEN
 #define E_FILNMLEN	18	/* # characters in a file name.  */
diff -rNbu binutils_060913_org/include/coff/x86_64.h binutils_060913/include/coff/x86_64.h
--- binutils_060913_org/include/coff/x86_64.h	1970-01-01 01:00:00.000000000 +0100
+++ binutils_060913/include/coff/x86_64.h	2006-08-17 09:12:24.000000000 +0200
@@ -0,0 +1,67 @@
+/* coff information for AMD 64.
+   Copyright 1995, 1996, 1999, 2001, 2002, 2004 Free Software Foundation, Inc.
+
+   This file is part of BFD, the Binary File Descriptor library.
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2 of the License, or
+   (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, write to the Free Software
+   Foundation, Inc., 51 Franklin Street - Fifth Floor, Boston, MA 02110-1301, USA.
+   
+   Written by Kai Tietz, OneVision Software GmbH&CoKg.
+*/
+
+#define L_LNNO_SIZE 2
+#define INCLUDE_COMDAT_FIELDS_IN_AUXENT
+#include "coff/external.h"
+
+/* Bits for f_flags:
+ 	F_RELFLG	relocation info stripped from file
+ 	F_EXEC		file is executable (no unresolved external references)
+ 	F_LNNO		line numbers stripped from file
+ 	F_LSYMS		local symbols stripped from file
+ 	F_AR32WR	file has byte ordering of an AR32WR machine (e.g. vax).  */
+
+#define F_RELFLG	(0x0001)
+#define F_EXEC		(0x0002)
+#define F_LNNO		(0x0004)
+#define F_LSYMS		(0x0008)
+
+#define AMD64MAGIC	0x8664
+
+#define AMD64BADMAG(x)	( (x).f_magic != AMD64MAGIC)
+#define IMAGE_NT_OPTIONAL_HDR64_MAGIC      0x20b
+
+#define OMAGIC          0404    /* object files, eg as output */
+#define ZMAGIC          IMAGE_NT_OPTIONAL_HDR64_MAGIC    /* demand load format, eg normal ld output 0x10b */
+#define STMAGIC		0401	/* target shlib */
+#define SHMAGIC		0443	/* host   shlib */
+
+/* define some NT default values */
+/*  #define NT_IMAGE_BASE        0x400000 moved to internal.h */
+#define NT_SECTION_ALIGNMENT 0x1000
+#define NT_FILE_ALIGNMENT    0x200
+#define NT_DEF_RESERVE       0x100000
+#define NT_DEF_COMMIT        0x1000
+
+/********************** RELOCATION DIRECTIVES **********************/
+
+struct external_reloc
+{
+  char r_vaddr[4];
+  char r_symndx[4];
+  char r_type[2];
+};
+
+#define RELOC struct external_reloc
+#define RELSZ 10
+
diff -rNbu binutils_060913_org/ld/ChangeLog binutils_060913/ld/ChangeLog
--- binutils_060913_org/ld/ChangeLog	2006-09-08 15:43:54.000000000 +0200
+++ binutils_060913/ld/ChangeLog	2006-09-13 11:20:51.000000000 +0200
@@ -1,3 +1,18 @@
+2006-09-13	Kai Tietz	<Kai.Tietz@onevision.com>
+
+	* configure:		Add new target x86_64-pc-mingw64
+	* configure.tgt:	Add definition of target emulation i386pep
+	* makefile.am:		Add new target files for target-all
+	* makefile.in:		Add new target files for target-all
+	* pe_dll.c:		Adjust to be inheritable by pep_dll.c as include. Fix memory out of bounds excess
+				for idata relocation section data.
+	* pep_dll.c:		Add target specific shared object handling
+	* pep_dll.h:		Add target specific definitions for shared object handling
+	* emulparams/i386pep.sh: Add new emulation params for target x86_64 coff
+	* emultempl/pep.em:	Add new emulation file for target x86_64 coff
+	* po/potfiles.in:		Add pepdll.c and pepdll.h
+	* scripttempl/pep.sc: Add linker script template for target x86_64 coff
+	
 2006-09-08  H.J. Lu  <hongjiu.lu@intel.com>
 
 	* ld.texinfo: Document --dynamic-list-cpp-typeinfo.
diff -rNbu binutils_060913_org/ld/Makefile.am binutils_060913/ld/Makefile.am
--- binutils_060913_org/ld/Makefile.am	2006-09-07 19:16:31.000000000 +0200
+++ binutils_060913/ld/Makefile.am	2006-09-11 14:46:32.000000000 +0200
@@ -239,6 +239,7 @@
 	ei386nto.o \
 	ei386nw.o \
 	ei386pe.o \
+	ei386pep.o \
 	ei386pe_posix.o \
 	elnk960.o \
 	em32relf.o \
@@ -411,15 +412,16 @@
 
 ALL_EMUL_EXTRA_OFILES = \
 	deffilep.o \
-	pe-dll.o
+	pe-dll.o \
+	pep-dll.o
 
 CFILES = ldctor.c ldemul.c ldexp.c ldfile.c ldlang.c \
 	ldmain.c ldmisc.c ldver.c ldwrite.c lexsup.c \
-	mri.c ldcref.c pe-dll.c
+	mri.c ldcref.c pe-dll.c pep-dll.c
 
 HFILES = ld.h ldctor.h ldemul.h ldexp.h ldfile.h \
 	ldlang.h ldlex.h ldmain.h ldmisc.h ldver.h \
-	ldwrite.h mri.h deffile.h pe-dll.h elf-hints-local.h
+	ldwrite.h mri.h deffile.h pe-dll.h pep-dll.h elf-hints-local.h
 
 GENERATED_CFILES = ldgram.c ldlex.c deffilep.c
 GENERATED_HFILES = ldgram.h ldemul-list.h deffilep.h
@@ -1099,6 +1101,9 @@
 ei386pe.c: $(srcdir)/emulparams/i386pe.sh \
   $(srcdir)/emultempl/pe.em $(srcdir)/scripttempl/pe.sc ${GEN_DEPENDS}
 	${GENSCRIPTS} i386pe "$(tdir_i386pe)"
+ei386pep.c: $(srcdir)/emulparams/i386pep.sh \
+  $(srcdir)/emultempl/pep.em $(srcdir)/scripttempl/pep.sc ${GEN_DEPENDS}
+	${GENSCRIPTS} i386pep "$(tdir_i386pe)"
 ei386pe_posix.c: $(srcdir)/emulparams/i386pe_posix.sh \
   $(srcdir)/emultempl/pe.em $(srcdir)/scripttempl/pe.sc ${GEN_DEPENDS}
 	${GENSCRIPTS} i386pe_posix "$(tdir_i386pe_posix)"
@@ -1965,6 +1970,12 @@
   ld.h $(INCDIR)/bin-bugs.h ldexp.h ldlang.h ldwrite.h \
   ldmisc.h ldgram.h ldmain.h ldfile.h ldemul.h $(INCDIR)/coff/internal.h \
   $(BFDDIR)/libcoff.h deffile.h pe-dll.h
+pep-dll.o: pep-dll.c ../bfd/bfd.h $(INCDIR)/ansidecl.h \
+  $(INCDIR)/symcat.h sysdep.h config.h $(INCDIR)/fopen-same.h \
+  $(INCDIR)/bfdlink.h $(INCDIR)/libiberty.h $(INCDIR)/safe-ctype.h \
+  ld.h $(INCDIR)/bin-bugs.h ldexp.h ldlang.h ldwrite.h \
+  ldmisc.h ldgram.h ldmain.h ldfile.h ldemul.h $(INCDIR)/coff/internal.h \
+  $(BFDDIR)/libcoff.h deffile.h pep-dll.h
 ldgram.o: ldgram.c ../bfd/bfd.h $(INCDIR)/ansidecl.h \
   $(INCDIR)/symcat.h sysdep.h config.h $(INCDIR)/fopen-same.h \
   $(INCDIR)/bfdlink.h ld.h $(INCDIR)/bin-bugs.h ldexp.h \
diff -rNbu binutils_060913_org/ld/configure.tgt binutils_060913/ld/configure.tgt
--- binutils_060913_org/ld/configure.tgt	2006-08-22 13:50:33.000000000 +0200
+++ binutils_060913/ld/configure.tgt	2006-09-11 14:43:28.000000000 +0200
@@ -155,6 +155,8 @@
 			  targ_extra_emuls="$targ_extra_emuls elf_x86_64"
 			fi
 			tdir_i386linux=${targ_alias}aout ;;
+x86_64-*-mingw64*) targ_emul=i386pep ;
+			targ_extra_ofiles="deffilep.o pep-dll.o" ;;
 x86_64-*-linux-*)	targ_emul=elf_x86_64
 			targ_extra_emuls="elf_i386 i386linux"
 			targ_extra_libpath=elf_i386
diff -rNbu binutils_060913_org/ld/emulparams/i386pep.sh binutils_060913/ld/emulparams/i386pep.sh
--- binutils_060913_org/ld/emulparams/i386pep.sh	1970-01-01 01:00:00.000000000 +0100
+++ binutils_060913/ld/emulparams/i386pep.sh	2006-07-28 12:43:22.000000000 +0200
@@ -0,0 +1,9 @@
+ARCH="i386:x86-64"
+SCRIPT_NAME=pep
+OUTPUT_FORMAT="pei-x86-64"
+RELOCATEABLE_OUTPUT_FORMAT="pe-x86-64"
+TEMPLATE_NAME=pep
+ENTRY="_mainCRTStartup"
+SUBSYSTEM=PE_DEF_SUBSYSTEM
+INITIAL_SYMBOL_CHAR=\"_\"
+TARGET_PAGE_SIZE=0x1000
